
	subroutine matvec1(m,n,n1,n2,a,b,c,d,h,phi,x,y,cinfo,svdc1
     1          ,svdc2,u,index,index2,mbdcnd,bda,bdb,nbdcnd,bdc,bdd,
     2          elmbda,idimf,work,uj,unj,ujf,fvec,bf)

        implicit real*8 (a-h,o-z)

C*************************************************************************
C   This routine
C -----------------------------------------------------------------------
 
        dimension phi(0:m,0:n),x(0:m),y(0:n),index(0:m,0:n),
     1          index2(0:m,0:n),uj(n2),u(0:m,0:n),ujf(n2)
     2         ,bda(0:n),bdb(0:n),bdc(0:m),bdd(0:m)
     3		,cinfo(n1,10),info(2),fvec(n2),bf(n2)
     4		,work(2*(m+1)*(n+1)),unj(n2),svdc1(n2,16)
     5		,svdc2(n1,6,3)

	do i=1,n2
	  uj(i) = ujf(i)
          unj(i) = 0.0
	enddo

	call poisson(m,n,n1,n2,a,b,c,d,h,phi,x,y,cinfo
     1          ,u,index,index2,uj,unj,mbdcnd,bda,bdb,nbdcnd,bdc,bdd,
     2          elmbda,idimf,work,svdc2)

c	call check(m,n,h,x,y,u,phi,e,i0,j0)         !# find the error
c	write(*,*)'error in matvec', e,i0,j0
c	write(*,*)'error in matvec', e

C------ using the coupled interpolating method to evaluate the
c--     Neumann BC, which leads also the residue for the Schur complement.

	ef = 0.0
	eun = 0.0

	do j=1,n-1
	  do i=1,m-1
	     nn1 = index(i,j)
	     n22 = index2(i,j)
	     if(n22 .gt. 0) then
               x1 = cinfo(nn1,1)
               y1 = cinfo(nn1,2)
               coc = cinfo(nn1,3)
               sic = cinfo(nn1,4)
	       curv = cinfo(nn1,5)

	call interp3(m,n,n1,n2,i,j,index,index2,h,a,b,c,d,phi,
     1                 u,uj,unj,x,y,cinfo,coc,sic,curv,x1,y1
     2		       ,svdc1,unin,unout,elmbda)

C------------------ Check error in u_n --------------

	       fvec(n22) = unin - ubc(x1,y1)

		tf = abs(fvec(n22))
               if(tf .gt. ef) then
		  ef = tf
		  i0 = i
		  j0 = j
		endif

	       fvec(n22) = fvec(n22) + bf(n22)
c	write(*,*)fvec(n22),n22,bf(n22)
	     endif
	  enddo
	enddo

c       write(*,*)'fvec ', ef,i0,j0
c	write(*,*)'error in u_n', eun,i1,j1
c	write(*,*)'fvec ', ef
c	write(*,*)'error in u_n', eun

	return
	end

