
	subroutine phiinf(m,n,i,j,h,phi,phx,phy,phxx,phyy,phxy)
	implicit double precision (a-h,o-z)

C-- subroutine phiinf find the derivatives information of a lvel set 
C   phi(x,y) at a grid point (x_i,y_j) using the central deifference.
 
        dimension phi(0:m,0:n)

	h2 = 2.0*h
        h1 = h*h

	if (i.eq. 0) return
	if (j .eq. 0) return
	if (i.eq. m) return
	if (j .eq. n) return

        phx = (phi(i+1,j) - phi(i-1,j))/h2
        phy = (phi(i,j+1) - phi(i,j-1))/h2
        phxx=(phi(i+1,j)+phi(i-1,j)-2.0*phi(i,j))/h1
        phyy= (phi(i,j+1)+phi(i,j-1)-2.0*phi(i,j))/h1
        phxy = (phi(i+1,j+1)+phi(i-1,j-1)-phi(i+1,j-1)
     >          -phi(i-1,j+1))/(4.0*h1)

	return
	end
